# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_test
# FileName:      db.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 11:11
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import pymysql

from InterfaceAutoTest01.common import log
from InterfaceAutoTest01.common.read_ini import ReadIni


class DB:
    def __init__(self):
        """链接数据库"""
        read_ini = ReadIni()
        try:
            self.conn = pymysql.Connect(
                host=read_ini.get_sql("host"),
                port=int(read_ini.get_sql("port")),
                user=read_ini.get_sql("user"),
                password=read_ini.get_sql("password"),
                database=read_ini.get_sql("database"),
                charset="utf8"
            )
            self.cursor = self.conn.cursor()
        except:
            log.error("链接数据库是吧，请查看配置文件sql节点下key和值是否正确")
            raise ValueError("链接数据库是吧，请查看配置文件sql节点下key和值是否正确")

    def close(self):
        """关闭连接数据库对象和游标对象"""
        self.conn.close()
        self.cursor.close()

    def select(self, sql):
        """查询"""
        try:
            self.cursor.execute(sql)
            select_result = self.cursor.fetchall()
            return select_result[0][0]
        except:
            log.error("执行查询sql语句错误，请查看sql_data文件内传入的查询sql语句是否错误")
            raise pymysql.MySQLError("执行查询sql语句错误，请查看sql_data文件内传入的查询sql语句是否错误")

    def delete(self, sql):
        """删除"""
        try:
            self.cursor.execute(sql)
            self.conn.commit()
        except:
            log.error("执行删除sql语句错误，请查看sql_data文件内传入的删除sql语句是否错误")
            raise pymysql.MySQLError("执行删除sql语句错误，请查看sql_data文件内传入的删除sql语句是否错误")