# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_test
# FileName:      read_json.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 10:55
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import json
import os
from InterfaceAutoTest01.common import log


def read_json(json_path):
    """打开json文件，获取里面数据并返回"""

    if type(json_path) == str:

        if json_path.endswith(".json") and os.path.isfile(json_path):
            try:
                with open(json_path, mode="r", encoding="utf-8") as f:
                    return json.load(f)
            except:
                log.error("打开json文件错误，请查看json文件内容是否正确")
                raise FileExistsError("打开json文件错误，请查看json文件内容是否正确")
        else:
            log.error("传入json文件路径错误，请查看传入json文件路径是否正确")
            raise FileNotFoundError("传入json文件路径错误，请查看传入json文件路径是否正确")
    else:
        log.error("传入json文件路径格式错误，请查看传入json文件路径是否为字符串")
        raise FileNotFoundError("传入json文件路径格式错误，请查看传入json文件路径是否为字符串")


if __name__ == '__main__':
    print(read_json("D:\hexi\python_test\InterfaceAutoTest01\data_config\case_dataq.json"))
