# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_test
# FileName:      requests_method.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 15:22
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import base64

import requests

from InterfaceAutoTest01.common import log
from InterfaceAutoTest01.common.read_ini import ReadIni


class RequestsMethod:
    def __init__(self):
        read_ini = ReadIni()
        login_url = read_ini.get_login_url("address")
        login_data = {"username": "admin", "password": base64.b64encode("123456".encode()).decode()}
        self.session = requests.sessions.Session()
        res = self.session.request(method="POST", url=login_url, json=login_data)
        self.session.headers.update({"Authorization": "Bearer "+res.json()["token"]})

    def request_all(self, method, url, mime, data):
        if mime == "json" or mime == "application/json":
            return self.session.request(method=method, url=url, json=data)

        elif mime == "x-www-form-urlencoded" or mime == "application/x-www-form-urlencoded":
            return self.session.request(method=method, url=url, data=data)

        elif mime == "form-data" or mime == "multipart/form-data":
            return self.session.request(method=method, url=url, files=data)

        elif mime == "query" or mime == "params" or mime == "param":
            return self.session.request(method=method, url=url, params=data)

        elif mime is None:
            return self.session.request(method=method, url=url)

        # 判断媒体类型是否为query|body 或者 body|query 、json|query、query|json
        elif mime == "query|body" or mime == "body|query" or mime == "json|query" or mime == "query|json":
            return self.session.request(method=method, url=url, params=data["query"], json=data["body"])
        else:
            log.error("传入的媒体类型的值错误，请察看excel中是否填入正确")
            raise NameError("传入的媒体类型的值错误，请察看excel中是否填入正确")


if __name__ == '__main__':
    r = RequestsMethod()