# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   python_test
# FileName:      BPM_test.py
# Author:       xxxxxxx
# Datetime:     2023/11/4 15:50
# Description:
# 命名规范：文件名全小写+下划线，类名大驼峰，方法和变量小写+下划线连接，
# 常量大写，变量和常量用名词，方法用动词
# ---------------------------------------------------------------------------
import allure
import pytest

from InterfaceAutoTest01.common import log
from InterfaceAutoTest01.common.read_excel import ReadExcel


class TestBPM:
    @allure.epic("BPM项目-何茜")
    # @allure.feature("模块名称")
    # @allure.story("接口名称")
    # @allure.title("用例标题")
    # @allure.severity("用例等级")
    @pytest.mark.parametrize("row, module_name, api_name, title, level, url, method, mime, case_data, expect_data, sql_type, sql_data, update_key", ReadExcel("BPM", "hexi").all_data())
    def test_bpm(self, req_fix, db_fix, row, module_name, api_name, title, level, url, method, mime, case_data, expect_data, sql_type, sql_data, update_key):
        # 影响allure报告的数据，不影响代码流程
        allure.dynamic.feature(module_name)
        allure.dynamic.story(api_name)
        allure.dynamic.title(title)
        allure.dynamic.severity(level)

        if sql_type == "select":
            value = db_fix.select(sql_data)
            case_data[update_key] = value

        if sql_type == "delete":
            db_fix.delete(sql_data)

        if sql_type == "delete|select" or sql_type == "select|delete":
            db_fix.delete(sql_data["delete"])
            value = db_fix.select(sql_data["select"])
            case_data[update_key] = value

        res = req_fix.request_all(method=method, url=url, mime=mime, data=case_data)
        try:
            for key in expect_data:
                assert res.json().get(key) == expect_data[key]
        except:
            log.error("断言失败" + "，用例数据为：" + str(case_data) + ",期望数据为：" + str(
                expect_data) + ",服务器返回的数据为：" + res.text)
            raise AssertionError("断言失败")


if __name__ == '__main__':
    pytest.main()